# ************************************************************
# @(#) web/webserver/cgi/Core/CounterBrowsers/Menubar.pm web_r3.6.0.8:cset.001111:22:33@(#)
#
#   Filename    : web/webserver/cgi/Core/CounterBrowsers/Menubar.pm
#
# *************************************************************
#
#                   COPYRIGHT NOTICE
#
# This file remains the intellectual property of:
#
#                       Vallent
#                    Spencer House
#                    23 Sheen Road
#                 Richmond, Surrey, UK
#
# Copyright (c) 2005 Vallent Software Systems UK. All rights reserved.
#
# **************************************************************
#
#   Description : 
#
# ************************************************************
package Core::CounterBrowsers::Menubar ;

require Core::Generate::Menubar ;

@ISA = qw(Core::Generate::Menubar) ;

# set up logging
require "$ENV{'NPRWEB_DIR'}/cgi/Lib/Logger.pm";
my $logger = new Logger( $ENV{NPRWEB_NPR_LOGFILE}, $ENV{NPRWEB_NPR_LOGLEVEL} );

##################################################################################
#
# Function    : new
#
# Parameters  : none
#
# Description : First thoughts
#
# Returns     : First thoughts, return a hash containg each input entry field plus
#               details
# Called By   :
#
##################################################################################
sub new {
    my $proto = shift;    # get the class name
    my $class = ref($proto) || $proto;
    # if class exists, use it else use reference.
    my $this = {MW_system => {},
             @_} ;

    bless $this, $class;
    return $this ;
}


##################################################################################
#
# Function    : _menuBar
#
# Parameters  : none
#
# Description : Build the Menu Bar
#
# Returns     : HTML output of Menu Bar
#
# Called By   : 
#
##################################################################################
sub _menuBar {
my ($this, $itemtype) = @_ ;
my $html = "" ;

$html .= qq[
<script language='JavaScript'>
	function downloadpage() {
		try {
			document.execCommand('SaveAs','0','report.html');
		}catch (e) {
			try{
				window.open('$this->{MW_system}{CGIPROG}/report.html?NPRSYS=$this->{MW_system}{'NPRSYS'}&NPRTARGET=$this->{MW_system}{datafile}.out','_self','menubar,toolbar,location,scrollbars,resizable,status');
			}catch (e) {
				alert("Browser does not support this feature!");
			}
		}
	}
</script>
];

$html .= qq[
<script language='JavaScript'>
<!--
function showToolbar() {
menu = new Menu();
];

$html .= $this->_menuDownloads($itemtype) ;
$html .= $this->_menuSend($itemtype) ;
$html .= $this->_menuView($itemtype) ;

$html .= qq[
menu.showMenu();
}
-->
</script>
<script language='JavaScript'>
showToolbar();
</script>
];

return $html ;
}

##################################################################################
#
# Function    : _menuView
#
# Parameters  : none
#
# Description : Build the addSubItems for View
#
# Returns     : HTML output
#
# Called By   : menuBar()
#
##################################################################################
sub _menuView {
   my ($this, $itemtype) = @_;
   my $html = "";

   $html .= qq[
menu.addItem("viewasid","View As", "View formats", null, null);
];

   for (lc($itemtype)) {
      /graph/ && do {
         $html .= qq[
menu.addSubItem("viewasid", "Tabular Report", "HTML", "#", "window.open('$this->{MW_system}{CGIPROG}/tabular.htm?NPRSYS=$this->{MW_system}{NPRSYS}&NPRTARGET=tabularcb.htm&amp;datafile=$this->{MW_system}{datafile}.ps.xml&amp;FileName=$this->{MW_system}{datafile}.ps.xml','Results_$this->{MW_system}{NPRSYS}','scrollbars,resizable,status');");
];
         last;
      };
      /report/ && do {
	 $gtype = lc("$ENV{IMAGE_FORMAT}") ;
         $html .= qq[
menu.addSubItem("viewasid", "Graphical Report", "$ENV{IMAGE_FORMAT}", "#", "window.open('$this->{MW_system}{CGIPROG}/graph.$gtype?NPRSYS=$this->{MW_system}{NPRSYS}&NPRTARGET=$this->{MW_system}{datafile}.$this->{MW_system}{ZOOMLEVEL}.$gtype','Results_$this->{MW_system}{NPRSYS}','resizable,width=600,height=500,scrollbars,status');");
];
         last;
      };
   }

   return $html;
}

##################################################################################
#
# Function    : _menuSend
#
# Parameters  : none
#
# Description : Build the addSubItems for Send
#
# Returns     : HTML output
#
# Called By   : menuBar()
#
##################################################################################
sub _menuSend {
   my ($this, $itemtype ) = @_;
   my $html = "";

   $html .= qq[
menu.addItem("sendasid","Send As", "Send formats", null, null);
];

   my $nprtarget = "cb".lc($itemtype).".htm" ;

   $html .= qq[
menu.addSubItem("sendasid", "Link", "Send as Link", "#", "window.open('$this->{MW_system}{CGIPROG}?NPRSYS=$this->{MW_system}{NPRSYS}&NPRTARGET=SendLink.htm&NEXTTARGET=$nprtarget&datafile=$this->{MW_system}{datafile}&ITEMTYPE=$this->{MW_system}{'ITEMTYPE'}&TECH_LAYER=$this->{MW_system}{TECH_LAYER}&CBTYPE=$this->{MW_system}{CBTYPE}&CBNAME=$this->{MW_system}{CBNAME}&USERNAME=$this->{MW_system}{USERNAME}&ACTION=form','link_$this->{MW_system}{NPRSYS}','resizable,width=500,height=600');");
];

   return $html;
}

1;
