# ************************************************************
# @(#) web/webserver/cgi/Core/GRPending.pm web_r3.6.0.8:cset.001111:22:33@(#)
#
#   Filename    : web/webserver/cgi/Core/GRPending.pm
#
# *************************************************************
#
#                   COPYRIGHT NOTICE
#
# This file remains the intellectual property of:
#
#                       Vallent
#                    Spencer House
#                    23 Sheen Road
#                 Richmond, Surrey, UK
#
# Copyright (c) 2005 Vallent Software Systems UK. All rights reserved.
#
# **************************************************************
#
#   Description :
#
# ************************************************************
#
package Core::GRPending ;

use Data::Dumper;

require Core::Configuration;
require Core::Generate::Menubar ;
require Core::CounterBrowsers::Menubar ;

require "$ENV{'NPRWEB_DIR'}/cgi/Lib/nprcookie.pl";

require Exporter;
@ISA = qw(Exporter Core::Configuration Core::Generate::Menubar Core::CounterBrowsers::Menubar);

# set up logging
require "$ENV{'NPRWEB_DIR'}/cgi/Lib/Logger.pm";
my $logger = new Logger( $ENV{NPRWEB_NPR_LOGFILE}, $ENV{NPRWEB_NPR_LOGLEVEL} );

##################################################################################
#
# Function    : new
#
# Parameters  : MW_system - hash of form variables,
#
# Description : Constructor for reports/graphs Form
#
# Returns     : object reference
#
# Called By   : build.htm
#
##################################################################################
sub new {
    my $proto = shift;    # get the class name
    my $class = ref($proto) || $proto;
    # if class exists, use it else use reference.
    my $this = { MW_system => {},
                              @_ } ;

    bless $this, $class;
    return $this ;
}

##################################################################################
#
# Function    : displayPending
# Description : 
#
##################################################################################
sub displayPending{
  my ($this) = @_ ;
  
  my $querystring = $ENV{QUERY_STRING};
  
	$querystring =~ s/\+/%20/g;
	my @applyConfig =  split ("&",$querystring);
	$logger->log( "parameters are @applyConfig", 4 );
	
	foreach (@applyConfig) {
		my ($cfgparam,$cfgvalue) = split("=",$_);
		$this->{param_set}{$cfgparam} = $cfgvalue;
	}
	$logger->log( "parameters are ".Dumper($this->{param_set}), 4 );
  
	my $title;
	if ($this->{param_set}{GRType} eq "displayError") {
		$title = "Error Generating Graph/Report";
	}elsif ($this->{param_set}{GRType} =~ "graph" || $this->{param_set}{GRType} =~ "report"){	
		$title = "$this->{param_set}{GRType}";
		$title =~ s/display//;
		$title = "\u$title Pending For Viewing";
	}elsif ($this->{param_set}{GRType} eq "cbr") {
		$title = "Counter Browser Reports Pending For Viewing";
	}elsif ($this->{param_set}{GRType} eq "cbg") {
		$title = "Counter Browser Graphs Pending For Viewing";
	}
	my $html;
	my ($itemname,$itemtype,$itemmodule);
	
	$this->{param_set}{GRType} = 'graph' if (!$this->{param_set}{GRType});
	
	if ($this->{param_set}{GRType} eq 'graph' || $this->{param_set}{GRType} eq 'report' || $this->{param_set}{GRType} eq 'cbg' || $this->{param_set}{GRType} eq 'cbr') {
		$html .= qq[
		    <p align=center class="bluehead0">$title<hr></p>
		];
		
		# Get username and stateid from HTTP_COOKIE
		if (&NPRGetCookies('NPRLOGON')) {
	    $curr_user = lc($cookie_hash{$this->{MW_system}{NPRSYS}}{USERNAME}); 
	    $curr_state  = $cookie_hash{$this->{MW_system}{NPRSYS}}{STATEID}; 
		}
		$logger->log( "do for user: $curr_user (stateid: $curr_state)", 4 );
		
		my $dirinaction = "$this->{MW_system}{MW_NPRWEB_DATADIR}/pending/";
	  opendir (PENDING, "$dirinaction") or die "Error, cannot access directory $!";
	 	
	  $html .= qq[ <UL class="root"> ];
	  while ( $filename = readdir( PENDING ) ) {
		  chop;
		  next if($filename eq "." || $filename eq "..");
		  #next if (!($filename =~ /^$curr_state/));					# skip if not meant for this user
		  
		  $logger->log( "read $filename", 4 );
		  
		  open (OUTFILE,"< $dirinaction/$filename") || die "Cannot read $filename";
		  while (<OUTFILE>) {
			  chomp;
			  my ($status,$id,$type,$desc,$user) = split("##");
			  #$logger->log( "next if ($user ne $curr_user)", 4 );
			  next if ($user ne $curr_user);
			  
			  my $description;
			  if(substr($type, 0, 2) ne 'cb') {				# Get description for normal graphs/reports
				  # Get full report/graph name
				  $TL = $this->{MW_system}{TECH_LAYER};
					my $conf_file = "$ENV{'NPRWEB_NPR_DIR'}/".$TL."/admin/".$TL."_Menu.cfg";
					my $configuration = Core::Configuration->new();
					my $tl_menu = $configuration->readTLMENU($conf_file);
					#my ($itemname,$itemtype,$itemmodule);
					my $skip = 0;
					while (@$tl_menu) {
						last if ($skip>0);
						my $root_head = {};
				    my $sub_mods = ();
				    my $head_value;
				    $root_head = shift @$tl_menu;
				    foreach my $key ( keys %$root_head ) {
					    last if ($skip>0);
					    $head_value = $$root_head{menuHeading};
					    my $mysub_mods = $$root_head{contents};
							my $count=0;    
							foreach my $myhead (@$mysub_mods) {
								last if ($skip>0);
								my $mysub_contents = $$myhead{'reports'};
								foreach my $mycont (@$mysub_contents) {
									last if ($skip>0);
									#$logger->log( "collector.pl read $$mycont{'code'}".Dumper(\%{$mycont}), 4 );
									if ($desc eq $$mycont{'code'}) {
										$skip = 1;
										$itemname = uc($$mycont{'name'});
										$itemtype = $$mycont{'reportType'};
										$itemmodule = $$mycont{'module'};
									} # END if
								} # END foreach my $mycont
							} # END foreach my $myhead
				    } # END foreach my $key
					} # END WHILE
					
					$description = "\"<b>$itemname</b>\" for \u$itemmodule \u$itemtype";
				}else{														# Get description for Counter Browsers
					my $cbcache = "$ENV{NPR_WWW_CACHE_DIR}/CBID-CBLONGNAME-CBTYPE-CGROUP_ID-C_DEF.dat";
					open(CBCACHE,"< $cbcache") || die "Cannot determine CB's name from $cbcache";
					my $found_cb=0;
					while (<CBCACHE>) {
						chomp;
						my ($cbid,$cblongname,$cbtype,$cgroup_id) = split (":");
						next if ($cbid ne $desc);
						next if ($found_cb == 1);
						if ($cbid eq $desc) {
							$found_cb = 1;
							if ($cbtype eq "S") {
								$description = "\"<b>$cblongname</b>\" For Historical Operations";
							}else{
								$description = "\"<b>$cblongname</b>\" For Daily Operation";
							}
						}
					}
					close(CBCACHE);
				} # END Getting description
			  
				my $imagewidth = 100;
				my $imageheight = 200;
				
			  if ($type eq $this->{param_set}{GRType} ) {
			  	if ($status==1) {	  		
			  		$html .= qq[ <li><a href="#" onclick=window.open('$CGIPROG?NPRSYS=$this->{MW_system}{NPRSYS}&NPRTARGET=GRPending.htm&GRType=displayError&id=$id&code=$desc&type=$itemtype&module=$itemmodule','user_$this->{MW_system}{NPRSYS}','scrollbars','width=$imagewidth,height=$imageheight')>Error generating $description [$id]</a></li> ];
		  		}else{
			  		$html .= qq[ <li><a href="#" onclick="window.open('$CGIPROG?NPRSYS=$this->{MW_system}{NPRSYS}&NPRTARGET=GRPending.htm&GRType=display$type&id=$id&ZoomLevel=1&code=$desc&type=$itemtype&module=$itemmodule','user_$this->{MW_system}{NPRSYS}','scrollbars','width=$imagewidth,height=$imageheight') ;">$description [$id]</a></li> ];
		  		}
		  	}
		  }
		  close (OUTFILE);
	  }
	  $html .= qq[ </UL>];
	  closedir(PENDING);
  } # END DISPLAY FROM MENU
  else	{ 
	  # get related graph/report by reading from data file
	  $this->{MW_system}{datafile} = $this->{param_set}{id};
	  $this->{MW_system}{ITEMNAME} = $this->{param_set}{code};
	  $this->{MW_system}{MODULE} = $this->{param_set}{module};
	  $this->{MW_system}{ITEMTYPE} = $this->{param_set}{type};
	  
	  my $ZoomLevel = $this->{param_set}{ZoomLevel};
	  if (!$ZoomLevel) {
		  $ZoomLevel = 1;
	  }
	  
	  if ($this->{param_set}{GRType} eq "displaygraph") {
		  	$logger->log( "will display for graph for $this->{param_set}{id}", 4 );
		    $html .= $this->displayGraph($this->{param_set}{id},$this->{param_set}{ZoomLevel},$this->{param_set}{code});
	  }elsif ($this->{param_set}{GRType} eq "displayreport") {
		  	$logger->log( "will display for report for $this->{param_set}{id}", 4 );
		  	$html .= $this->displayPreReport($this->{param_set}{id});
	  }elsif ($this->{param_set}{GRType} eq "displaycbr") {
			  $logger->log( "will display for CB report for $this->{param_set}{id}", 4 );
			  $html .= $this->displayCBReport($this->{param_set}{id});
	  }elsif ($this->{param_set}{GRType} eq "displaycbg") {
			  $logger->log( "will display for CB graph for $this->{param_set}{id}", 4 );
			  $html .= $this->displayGraph($this->{param_set}{id},$this->{param_set}{ZoomLevel},$this->{param_set}{code});
	  }elsif ($this->{param_set}{GRType} eq "displayError") {
			  my $errorfile = "$this->{param_set}{id}.err";
			  $html .= "<b>Error Generating Graph/Report</b><br>";
			  open (ERRFILE,"< $this->{MW_system}{MW_NPRWEB_DATADIR}/$errorfile");
			  while (<ERRFILE>) {
				  $html .= $_;
			  }
			  close(ERRFILE);
			  
			  unlink("$this->{MW_system}{MW_NPRWEB_DATADIR}/pending/$this->{param_set}{id}");
	  }
  }

  return $html;
}

##################################################################################
#
# Function    : workaoutImage
# Description : create Graphical report
#
##################################################################################
sub workaoutImage{
  my ($this,$id,$ZoomLevel) = @_ ;
  
  require "$ENV{'NPRWEB_DIR'}/cgi/Core/Generate.pm";
	my $generate = new Core::Generate(MW_system => $this->{MW_system});
	#my $ZoomLevel = 1;
	my $gfile;
	my $gtype = $ENV{'IMAGE_FORMAT'};
	
	if (lc($gtype) eq "ps") {
    return 0;
  } elsif (lc($gtype) eq "pdf") {
    $error = $generate->PS2PDF($id) ;
    $gfile = "$this->{MW_system}{MW_NPRWEB_DATADIR}/$id.$ZoomLevel.pdf";
  } elsif (lc($gtype) eq "png") {
    $error = $generate->PS2PNG($id, $ZoomLevel);
    $gfile = "$this->{MW_system}{MW_NPRWEB_DATADIR}/$id.$ZoomLevel.png";
  } elsif (lc($gtype) eq "gif") {
    $error = $generate->PS2GIF($id, $ZoomLevel);
    $gfile = "$this->{MW_system}{MW_NPRWEB_DATADIR}/$id.$ZoomLevel.gif";
  } else {
    $errormessage = "1012; RunGraph:  Unknown graph type: ${gtype}" ;
    return $errormessage ;
  }
  
  return $error;
}

##################################################################################
#
# Function    : displayGraph
# Description : display selected pending graph
#
##################################################################################
sub displayGraph{
  my ($this,$id,$ZoomLevel,$code) = @_ ;
  
  if ($this->{param_set}{GRType} eq "displaygraph") {
  	$this->readReportCfg();
	}
  
	my $gtype = $ENV{'IMAGE_FORMAT'};
	$gfile = "$this->{MW_system}{MW_NPRWEB_DATADIR}/$id.$ZoomLevel.".lc($gtype);
	$error = $this->workaoutImage($id,$ZoomLevel);
	if ($error) {
		unlink("$this->{MW_system}{MW_NPRWEB_DATADIR}/pending/$id");
		return qq[
	  	<script language='JavaScript'>
	  		window.resizeTo(400,150);
	  	</script>
			<p><center><b>Error converting $id.ps to $gtype.<br>The graphs may have no data.</b></center></p>
		];
	}
	
	# Work out the image dimensions
	$cmd = "alchemy -x1 ${gfile} ";
	&main::wwwnprexec($cmd, \$exitstatus, \@cmdoutput, \@erroroutput);
	$exitstatus and die "1015; graphdata.htm:  Image Alchemy error:  ($exitstatus)\n" . join("", @erroroutput)."\n";
	
	$imagewidth = 0;
	$imageheight = 0;
	foreach(@cmdoutput) {
	  /Width:\s+(\d*)/ and $imagewidth = $1;
	  /Height:\s+(\d*)/ and $imageheight = $1;
  }
  
  $logger->log( "collector.pl workout for $gfile with $imagewidth x $imageheight", 4 );
	 
	 my $itemtype = $this->{param_set}{type};
	 my $itemmodule = $this->{param_set}{module};
	 my $itemcode = $this->{param_set}{code};
	 my $itemdisplay = $this->{param_set}{GRType};
  
  # remove from pending display
  unlink("$this->{MW_system}{MW_NPRWEB_DATADIR}/pending/$id");
  
  my $imgfile = "$id.$ZoomLevel.".lc($gtype);
  
	my $outhtml;
	
	$winwidth = $imagewidth + 100;
	$winheight = $imageheight + 200;
	
	$winwidth=770 if ($winwidth>770);
	$winheight=660 if ($winheight>660);
	
  $outhtml .= qq[
  	<script language='JavaScript'>
  		function resizeme() {
	  		window.resizeTo($winwidth,$winheight);
  		}
  	</script>
	];

	if ($this->{param_set}{GRType} eq 'displaycbr' or $this->{param_set}{GRType} eq 'displaycbg') {
		require "$ENV{'NPRWEB_DIR'}/cgi/Core/CounterBrowsers/Menubar.pm";
		my $cbmenu = new Core::CounterBrowsers::Menubar(MW_system => $this->{MW_system});
		$outhtml .= $cbmenu->_menuBar(graph) ;
	}else{
		$outhtml .= $this->_menuBar(graph) ;
	}
	$outhtml .= qq[<br><br><br>];
		
	 $outhtml .= qq[<center><img src="$this->{MW_system}{CGIPROG}?NPRSYS=$this->{MW_system}{NPRSYS}&NPRTARGET=$imgfile&type=$itemtype" width=$imagewidth height=$imageheight border=0 align=center></center>];
	 
	 $outhtml .= qq[<center>
		<table border=\"0\">
		   <tr>
		     <td><p class=bluehead1> Zoom : </p></td>
		     <td> <input type=\"image\" border=\"0\" name=\"pdf\" src=\"/images/buttons/zoom1.gif\" alt=\"Zoom x1\" onclick=\"window.open('$CGIPROG?NPRSYS=$this->{MW_system}{NPRSYS}&NPRTARGET=GRPending.htm&GRType=$itemdisplay&id=$id&ZoomLevel=1&type=$itemtype&module=$itemmodule&code=$itemcode','user_$this->{MW_system}{NPRSYS}','scrollbars','resizable')\"></td>
		     <td> <input type=\"image\" border=\"0\" name=\"pdf\" src=\"/images/buttons/zoom2.gif\" alt=\"Zoom x2\" onclick=\"window.open('$CGIPROG?NPRSYS=$this->{MW_system}{NPRSYS}&NPRTARGET=GRPending.htm&GRType=$itemdisplay&id=$id&ZoomLevel=2&type=$itemtype&module=$itemmodule&code=$itemcode','user_$this->{MW_system}{NPRSYS}','scrollbars','resizable')\"></td>
		     <td> <input type=\"image\" border=\"0\" name=\"pdf\" src=\"/images/buttons/zoom3.gif\" alt=\"Zoom x3\" onclick=\"window.open('$CGIPROG?NPRSYS=$this->{MW_system}{NPRSYS}&NPRTARGET=GRPending.htm&GRType=$itemdisplay&id=$id&ZoomLevel=3&type=$itemtype&module=$itemmodule&code=$itemcode','user_$this->{MW_system}{NPRSYS}','scrollbars','resizable')\"></td>
		   </tr>
			</table></center>
	 ];
  
  return $outhtml;
};

##################################################################################
#
# Function    : displayPreReport
# Description : display selected pending report
#
##################################################################################
sub displayPreReport{
  my ($this,$id) = @_ ;
  
  $this->readReportCfg();
  
  my $html;
  my $prefile = "$this->{MW_system}{MW_NPRWEB_DATADIR}/$id";
  #$html = qq[<center>"$this->{MW_system}{MW_NPRWEB_DATADIR}/$id"</center>];
  
	# create html report stored into data dir so that can download as html (BUG57055)
	#		this will be used when downloading report as html
	open(OUTDATA,">$prefile.out") || die "cannot create output file";
	print OUTDATA "<html><body>";
  
  $logger->log( "GRPending.pm : displayPreReport for $prefile", 4 );
  	
  $html .= qq[
  	<script language='JavaScript'>
  		function resizeme() {
	  		window.resizeTo(700,600);
  		}
  	</script>
	];
  
  $html .= $this->_menuBar(report) ;
	$html .= qq[<br><br><br>];
  
  my $htmldata .= "<PRE class='preformatted'>\n";
	open(DATAFILE, "<$prefile") or die "GRPending.pm : failed to access $prefile";
	while(<DATAFILE>) {
		next if(/^#/);
		$htmldata .= $_;
	}
	close(DATAFILE);
	$htmldata .= "</PRE>\n";
	
	$html .= $htmldata;	
	print OUTDATA $htmldata;
	print OUTDATA "</body></html>";
	close(OUTDATA);
	$logger->log("OUTDATA $datadir/$this->{MW_system}{datafile}.out generated",4);
  
  # remove from pending display
  unlink("$this->{MW_system}{MW_NPRWEB_DATADIR}/pending/$id");
  
  return $html;
};

##################################################################################
#
# Function    : displayCBReport
# Description : display selected pending report
#
##################################################################################
sub displayCBReport{
  my ($this,$id) = @_ ;  
  my $html;
  
  my $prefile = "$this->{MW_system}{MW_NPRWEB_DATADIR}/$id";
	# create html report stored into data dir so that can download as html (BUG57055)
	#		this will be used when downloading report as html
	open(OUTDATA,">$prefile.out") || die "cannot create output file";
	print OUTDATA "<html><body>";
  
  $error = $this->workaoutImage($id,1);
  
	require "$ENV{'NPRWEB_DIR'}/cgi/Core/CounterBrowsers/Menubar.pm";
	my $cbmenu = new Core::CounterBrowsers::Menubar(MW_system => $this->{MW_system});
  $html .= $cbmenu->_menuBar(report) ;
	$html .= qq[<br><br><br>];
		
  $html .= qq[
  	<script language='JavaScript'>
  		function resizeme() {
	  		window.resizeTo(700,600);
  		}
  	</script>
	];
  
  require "Lib/tabularcb.pl" ;
  my $xmlfile = "$this->{MW_system}{MW_NPRWEB_DATADIR}/$id.ps.xml";
  $logger->log("xml DataFile is $xmlfile",4);
  
	# Print out the main title of the tabular CB
	my $htmldata .= "<center><h3 class='Title'>";
	if($this->{MW_system}{CBTYPE} eq 'R') {
	        $htmldata .= 'Daily Operations';
	} elsif($this->{MW_system}{CBTYPE} eq 'S') {
	        $htmldata .= 'Historical Operations';
	}
	$_ = $this->{MW_system}{CBNAME};
	substr($_, (index($_, ' ')), 1) = ':';
	($cbid, $cbname) = split /:/;
	$htmldata .= ": $cbname</h3>";
  
  $htmldata .= &FormatTabCB($xmlfile) ;
  $htmldata .= "</center>";
  
	$html .= $htmldata;
	print OUTDATA $htmldata;
	print OUTDATA "</body></html>";
	close(OUTDATA);
	$logger->log("OUTDATA $prefile.out generated",4);
  
  unlink("$this->{MW_system}{MW_NPRWEB_DATADIR}/pending/$id");
  
  return $html;
};

1; # return true
