# ************************************************************
# @(#) web/webserver/cgi/Core/Generate/Menubar.pm web_r3.6.0.8:cset.001111:22:33@(#)
#
#   Filename    : web/webserver/cgi/Core/Generate/Menubar.pm
#
# *************************************************************
#
#                   COPYRIGHT NOTICE
#
# This file remains the intellectual property of:
#
#                       Vallent
#                    Spencer House
#                    23 Sheen Road
#                 Richmond, Surrey, UK
#
# Copyright (c) 2005 Vallent Software Systems UK. All rights reserved.
#
# **************************************************************
#
#   Description : 
#
# ************************************************************
package Core::Generate::Menubar ;

require Core::MenuLib ;

@ISA = qw(Core::MenuLib) ;

# set up logging
require "$ENV{'NPRWEB_DIR'}/cgi/Lib/Logger.pm";
my $logger = new Logger( $ENV{NPRWEB_NPR_LOGFILE}, $ENV{NPRWEB_NPR_LOGLEVEL} );

##################################################################################
#
# Function    : new
#
# Parameters  : none
#
# Description : First thoughts
#
# Returns     : First thoughts, return a hash containg each input entry field plus
#               details
# Called By   :
#
##################################################################################
sub new {
    my $proto = shift;    # get the class name
    my $class = ref($proto) || $proto;
    # if class exists, use it else use reference.
    my $this = {MW_system => {},
             @_} ;

    bless $this, $class;
    return $this ;
}

##################################################################################
#
# Function    : _menuBar
#
# Parameters  : none
#
# Description : Build the Menu Bar
#
# Returns     : HTML output of Menu Bar
#
# Called By   : 
#
##################################################################################
sub _menuBar {
my ($this, $itemtype) = @_ ;
my $html = "" ;

$html .= qq[
<script language='JavaScript'>
	function downloadpage() {
		try {
			document.execCommand('SaveAs','0','report.html');
		}catch (e) {
			try{
				window.open('$this->{MW_system}{CGIPROG}/report.html?NPRSYS=$this->{MW_system}{'NPRSYS'}&NPRTARGET=$this->{MW_system}{datafile}.out','_self','menubar,toolbar,location,scrollbars,resizable,status');
			}catch (e) {
				alert("Browser does not support this feature!");
			}
		}
	}
</script>
];

$html .= qq[
<script language='JavaScript'>
<!--
function showToolbar() {
menu = new Menu();
];

$html .= $this->_menuDownloads($itemtype) ;
$html .= $this->_menuFavourites() ;
$html .= $this->_menuRelations() ;

$html .= qq[
menu.showMenu();
}
-->
</script>
<script language='JavaScript'>
showToolbar();
</script>
];

return $html ;
}

##################################################################################
#
# Function    : _menuDownloads
#
# Parameters  : none
#
# Description : Build the addSubItems for the downloads
#
# Returns     : HTML output
#
# Called By   : menuBar()
#
##################################################################################
sub _menuDownloads {
my ($this, $itemtype ) = @_;
my $html = "";

$html .= qq[
menu.addItem("downloadasid","Download As", "Download formats", null, null);
];

for (lc($itemtype)) {
   /graph/ && do {
      $html .= qq[
menu.addSubItem("downloadasid", "PDF", "PDF", "#", "window.open('$this->{MW_system}{CGIPROG}/graph.pdf?NPRSYS=$this->{MW_system}{NPRSYS}&NPRTARGET=graphdatapdf.htm&amp;datafile=$this->{MW_system}{'datafile'}&amp;FileName=$this->{MW_system}{datafile}.pdf','Results_$this->{MW_system}{NPRSYS}','menubar,toolbar,location,scrollbars,resizable,status');");
menu.addSubItem("downloadasid", "Postscript", "Postscript" ,"$this->{MW_system}{CGIPROG}/graph.ps?NPRSYS=$this->{MW_system}{NPRSYS}&NPRTARGET=$this->{MW_system}{datafile}.ps", null, "_self");
];
      last;
   };
   /report/ && do {
      $html .= qq[
menu.addSubItem("downloadasid", "HTML", "HTML", "#", "downloadpage()");
menu.addSubItem("downloadasid", "Spreadsheet", "SpreadSheet", "#", "window.open('$this->{MW_system}{CGIPROG}/report.csv?NPRSYS=$this->{MW_system}{'NPRSYS'}&NPRTARGET=$this->{MW_system}{datafile}.csv','_self','menubar,toolbar,location,scrollbars,resizable,status');");
];
      last;
   };
}

return $html;
}

##################################################################################
#
# Function    : _menuFavourites
#
# Parameters  : none
#
# Description : Build the addSubItems for the favourites
#
# Returns     : HTML output
#
# Called By   : menuBar()
#
##################################################################################
sub _menuFavourites {
my ($this) = @_;
my $html = "";
my $URL = $ENV{'URL'};

$vars = $linkvars = qq{NPRSYS=$this->{MW_system}{'NPRSYS'}&NPRTARGET=SaveFave.htm&NEXTTARGET=$this->{MW_system}{NPRTARGET}&datafile=$this->{MW_system}{datafile}};
$linkvars =~ s/SaveFave/SendLink/ ;
$linkvars .= qq{&ITEMTYPE=$this->{MW_system}{'ITEMTYPE'}&TECH_LAYER=$this->{MW_system}{'TECH_LAYER'}&USERNAME=$this->{MW_system}{'USERNAME'}&ACTION=form};
$features = qq{resizable,width=500,height=600};

$html .= qq[
menu.addItem("saveid","Favourites...", "save to favourites", null, null);
menu.addSubItem("saveid", "Standard", "Save as Favourite", "#", "window.open('/cgi/Favourites/savefave.pl?$vars', 'faves_$this->{MW_system}{NPRSYS}', '$features')");\n
];

if (lc($this->{MW_system}{'USERNAME'}) eq 'system') {
$html .= qq[
menu.addSubItem("saveid", "Pregenerated Daily", "Pregenerated Daily", "#", "window.open('/cgi/Favourites/savefave.pl?$vars&pregen=daily', 'faves_$this->{MW_system}{NPRSYS}', '$features')");
menu.addSubItem("saveid", "Pregenerated Weekly", "Pregenerated Weekly", "#", "window.open('/cgi/Favourites/savefave.pl?$vars&pregen=weekly', 'faves_$this->{MW_system}{NPRSYS}', '$features')");
menu.addSubItem("saveid", "Pregenerated Monthly", "Pregenerated Monthly", "#", "window.open('/cgi/Favourites/savefave.pl?$vars&pregen=monthly', 'faves_$this->{MW_system}{NPRSYS}', '$features')");
];
}


for (lc($itemtype)) {
   /graph/ && do {
      # fix for cells
      $URL =~ s/frm_ConvCellname\.htm/graphdata.htm/;
      $URL =~ s/CELLID=.*?(&|$)/CELLID=$this->{MW_system}{'CELLID'}$1/;
      # fix for apt cells
      $URL =~ s/apt\%2Ffrm_ConvAnomname\.htm/graphdata.htm/;
      last;
   };
}

# URL-encode URL
$URL =~ s/([^a-zA-Z0-9_\-.])/uc sprintf("%%%02x",ord($1))/eg;
$html .= qq[
menu.addSubItem("saveid", "Send Link", "Send as Link", "#", "window.open('$this->{MW_system}{CGIPROG}?$linkvars&URL=$URL', 'link_$this->{MW_system}{NPRSYS}', '$features')");\n
];

return $html;
}

##################################################################################
#
# Function    : _menuRelations
#
# Parameters  : none
#
# Description : Build the addSubItems for the related graphs and reports
#
# Returns     : HTML output
#
# Called By   : menuBar()
#
##################################################################################
sub _menuRelations {
my ($this) = @_;
my $html = "";

$html .= qq[
menu.addItem("relatedid","Related Graphs and Reports", "Related Graphs and Reports", null, null);
];

my @relations = split ( /:/, $this->{MW_system}{RELATIONS} );		# List of relations for this graph or report

my $GotSome = 0;

# Get info for related graphs and reports from config files
%params = $this->get_relation_params($this->{MW_system}{'TECH_LAYER'}, \@relations);

foreach $Name ( @relations ) {
   $GotSome++;
   #Look through GSM_Menu.pm for he relevent graphs
   # Need to find NPRSYS NPRTARGET MODULE TECH_LAYER ITEM_TYPE ITEMNAME and  ITEMDESC

   # %params is a hash of hashes, so we need to access teh individual hashes
   my %tmp_hash = %{$params{$Name}};

   # record the current $Desc to pass as ITEMDESC later
   $Desc = $tmp_hash{ITEMDESC};

   # Name according to first letter of graph/report name
   $Desc = "Summary ".$Desc if uc($Name) =~ /^S/;
   $Desc = "Daily ".$Desc if uc($Name) =~ /^D/;
   # Bug 23555 If it ends in 'R' assume it is a report, otherwise assume it is a graph
   if ( $Name =~ /R$/ ) {
      $Desc = $Desc." Report" unless $Desc =~ /report/i;
   } else {
      $Desc = $Desc." Graph" unless $Desc =~ /graph/i;
   }

   $html .= qq[
menu.addSubItem("relatedid", "$Desc", "$Desc", "$tmp_hash{CGIPROG}?NPRSYS=$tmp_hash{NPRSYS}&NPRTARGET=$tmp_hash{NPRTARGET}&MODULE=$tmp_hash{MODULE}&TECH_LAYER=$tmp_hash{TECH_LAYER}&ITEMTYPE=$tmp_hash{ITEMTYPE}&ITEMNAME=$tmp_hash{ITEMNAME}&ITEMDESC=$tmp_hash{ITEMDESC}", null, "Main")
]; 
                
} 

# No Related Graph/Report define
if( $GotSome == 0 ) {
   $html .= qq[
menu.addSubItem("relatedid", "None Listed", null, null, "return false", null)
];
}

$logger->log("Finished generating relations",4);

return $html;
}

1;
