#!/usr/bin/perl
#########################################
# @(#) web/webserver/cgi/Core/changepw.pl web_r3.6.0.8:cset.001111:22:33@(#) @(#) web/webserver/cgi/Core/changepw.pl web_r3.6.0.8 %H%
#
# Author: David Fisher
#
# Description:
# This script changes the USERS password.
# The STATEID file, Database & COOKIE all
# have to be updated.
#
# Returns: nothing
#
# Copyright (c) 2005 Vallent Software Systems UK. All rights reserved.
#########################################

require "../Lib/nprcookie.pl"; 
require "dotsh.pl";

use CGI qw(param);
use strict;

# Get required passed variables
my $USER=param('user');
my $PASSWORD=param('passwd');
my $NEW_PASSWD=param('passwd1');
my $NPRSYS=param('NPRSYS');
my $NPR_DIR=param('NPR_DIR');

# Get other environment variables
dotsh("../../$NPRSYS/webconfig.sh");
require "../Lib/nprfns.pl";

# Initialise variabels
my ($cookie, $message, %hash, $name, $val);

# Establish USERS stateid file name
my $STATEID=param('stateid');
my $FILE="./../../$NPRSYS/data/$STATEID.dat";

# Get the variables from $NPR_DIR/etc/loginconf
my $loginconf_file = "$NPR_DIR/etc/loginconf";

dotsh($loginconf_file) or ($message = "has not been changed. <br>The file $NPR_DIR/etc/loginconf could not be read.");

# Attempt to set new password, first try and open the USERS
# stateid file. This will be used to confirm current password &
# USER name.
unless (open (FILE, "<$FILE")){
	$message="has not been changed, as your log-on details";
	$message .=" could not be accessed";
}
else{
	while (<FILE>){
		chomp;
		($name, $val)= split(/:/,$_,2);
		$hash{$name}=$val;
	}
	close (FILE);
	
			#### START HERE	FOR BUG53272 : check password format first before proceed
			my $TMP_DIR= param('TMP_DIR');
			my $pwdscript=$TMP_DIR."/pwd.$$.tsl";
			my $pwdscripttemp=$TMP_DIR."/pwdtemp.$$.tsl";
			my $validformat=0;		# valid format will have value 0
			
			# fix for bug 55953: Passworf with 3 charcters long is acceptable in web (on HP machine)
			my $passformat = eval $ENV{NPR_PASSWORD_FORMAT};		# in HP will write as PASSFORMAT_ 'len(%0)>=45'
			if (!$passformat) {																	#	but in SUN correcly PASSFORMAT_ len(%0)>=45
				$passformat = $ENV{NPR_PASSWORD_FORMAT};					# eval will remove the ''
			}
			if( $ENV{NPR_PASSWORD_FORMAT} ) {				
				open(PWDSCRIPT, ">$pwdscript") or die "changepw.pl: Cannot create tsl script $pwdscript.\n";
				print PWDSCRIPT qq{
					query define PASSFORMAT_ $passformat ;
					query define v_return PASSFORMAT_(\"$NEW_PASSWD\") ;
					pagestyle startline=1 lmargin=1 rmargin=80 length=99999
					printer output=file, filename=\"$pwdscripttemp\"
					report on
					printer on
					shell echo [v_return]
					printer off
				};
				close(PWDSCRIPT);
				
				my $CacheBufferSize = $ENV{'BUFFERSIZE'};
				system( "tsl -nomap -nowindow -buffersize $CacheBufferSize $pwdscript");
				unlink $pwdscript;
					
				open( TEMPFILE, $pwdscripttemp );
				my $status;
				while (<TEMPFILE>) {
					$status=$_;						
				}
				close (TEMPFILE);
				unlink $pwdscripttemp;
				
				if ($status =~ "NO") {
					$validformat=1;
					$message = $ENV{NPR_PASSWORD_HELP};
				}
			} # END CHECK NPR_PASSWORD_FORMAT
			#### END HERE	FOR BUG53272

	# Check that the USER is correct & the password is correct

	if (($USER eq $hash{USERNAME}) && ($PASSWORD eq $hash{PASSWORD}) && ($validformat==0)){
		unless (open (FILE, ">$FILE")){
		$message="change failed. You will need to log on again using";
		$message .=" your original password";
		}
		else{
			# STEP 1 of 3
			# Update the database with the new password
			my $DBNAME = param('DBNAME');
                        my $ADMINDBNAME = param('ADMINDBNAME');
			my $TMP_DIR= param('TMP_DIR');

			my $tslscript=$TMP_DIR."/cp$$.tsl";

			# Bug 24367 Create a file for the TSL errors, if any
			my $errorfile=$TMP_DIR."/err$$.tsl";
			
			# Generate the TSL script
			if(! open (TSLSCRIPT, ">$tslscript")){
				$message .= "has not been changed<br>\n";
				$message .= "changepw.pl: Could not create tsl script $tslscript.\n";
			}else{
                        # get the time since epoch to update time fields
                        my $epoch_time = time();
			print TSLSCRIPT qq{
query set %USER "$USER";
query set %PASS "$PASSWORD";
query open $DBNAME;
query set %PASS "$NEW_PASSWD";
query close;};
                        # then update the last PWCHANGED field in NPRUSERS
                        if( $ENV{NPR_PASSWORD_AGE} ) {
                                my $uc_user = uc($USER);
                                print TSLSCRIPT qq{
query set %USER "LAUNCHER";
query set %PASS "LAUNCHER";
query open $ADMINDBNAME;
query UPDATE $epoch_time AS pwchanged FROM nprusers WHERE npruser = "$uc_user";
query close;};

                        }
			close (TSLSCRIPT);
		
			# Execute TSL script	
			my $TQL_CLIENT_DIR= param('TQL_CLIENT');
			my $TQL_SERVER_DIR= param('TQL_SERVER');
			my $LM_LICENSE_FILE= param('LM_FILE');

			# Bug 21396 Change password fails on client/server
			# SKT 07/06/01 Get the following parameters from cgi request if they are declared
			my $QYSERVICE=param('QYSERVICE');
			my $QYHOST=param('QYHOST');
			my $QYINT=param('QYINT');

			my $error="";

			# SKT 22/05/01 Split system call into readable lines and send stdout and stderr to a file
			my $command = "/bin/sh -c ";
			$command .= "\"TQL_CLIENT_DIR=$TQL_CLIENT_DIR; export TQL_CLIENT_DIR;";
			$command .= "TQL_SERVER_DIR=$TQL_SERVER_DIR; export TQL_SERVER_DIR;";
			# Bug 21396
			# SKT 06/06/01 For client/server installation QYINT needs to be set too
			# SKT 07/06/01 As does QYHOST, QYSERVICE and QYINT
			( $command .= "QYSERVICE=$QYSERVICE; export QYSERVICE;") if ($QYSERVICE);
			( $command .= "QYHOST=$QYHOST; export QYHOST;") if ($QYHOST);
			( $command .= "QYINT=$QYINT; export QYINT;") if ($QYINT);	
			$command .= "LM_LICENSE_FILE=$LM_LICENSE_FILE; export LM_LICENSE_FILE;";
			$command .= "$TQL_CLIENT_DIR/bin/tsl -nowindow $tslscript\" ";
			$command .= ">$errorfile 2>&1";

			system($command);

			unlink $tslscript;
			if ( -s $errorfile ) {
                              if(!open( ERRORS, "$errorfile")){
					$message .= "has not been changed due to a TSL error:<br>";
					$message .= "Error unknown, unable to open $errorfile<br>";
			      }else{
					while (<ERRORS>) {
					$error .= "<P>" . $_ . "</P>";
			      }
					close ERRORS;
					$message = "has not been changed due to a TSL error:";
					$message .= $error;
			      }

			      # Bug 24369 Reset to the original password in case of errors
			      # SKT 22/05/01  
			      $NEW_PASSWD = $PASSWORD;
                        }

			unlink $errorfile;

			# STEP 2 of 3
			# Modify STATEID FILE
			$hash{PASSWORD}=$NEW_PASSWD;
			foreach (sort keys %hash){
				print FILE $_.":".$hash{$_}."\n";	
			}
			close (FILE);

			# STEP 3 of 3
			# And finally, update the COOKIE
			my %cookie_hash;
			$cookie_hash{$NPRSYS}{'USERNAME'} = $USER;
			$cookie_hash{$NPRSYS}{'PASSWORD'} = crypt($NEW_PASSWD, $USER);
			$cookie_hash{$NPRSYS}{'STATEID'} = $STATEID;

                        my $cookieFile = "./../../$NPRSYS/$STATEID.tmp";
                        open(COOKIE, ">${cookieFile}");
                        select(COOKIE);
                            NPRSetCookiePath('/cgi/');
                            NPRSetCookies( 'NPRLOGON', %cookie_hash);
                        close(COOKIE);
                        open(COOKIE, "${cookieFile}");
                            $cookie = join("", <COOKIE>);
                        close(COOKIE);
                        unlink($cookieFile);

			# Bug 24368 Get error messages sent to user in case of TSL problem
			# SKT 22/05/01
			$message.="has been changed" unless ($error);
			}
		}
	}
	else{$message.="<br>Your password was incorrect";}
}
 
#--------------------------------------------------------------------
# Produce HTML display

# Bug #27897 - When a successful password change has occured on the
# expired password page, log the user in automatically
my $pwExpSubmit;

if ( $message =~ /has been changed/ ) {
   $pwExpSubmit = qq[
          // only submit the parent form if it was for an expired password
          var pWin=window.opener.document;
          if ( pWin.title.match(/Expired Password/) ) {
             window.setTimeout('window.opener.document.LoginForm.submit(); window.close(); return false;', 2000);
         };
      ];

   # Good pw change update the messgae
   $message = "<p class='bluehead2'>Your password $message</p>";
}else{
   #Bad password change, flag the error
   $message = warn_dialog("Change failed.<br>$message");
}

print STDOUT <<END_of_html;
Content-type: text/html
Pragma: no-cache
$cookie

<HTML>
<head>
<link rel="STYLESHEET" type="text/css" href="/css/style.css">
<script language=javascript>
      function submitParentForm() {
          $pwExpSubmit
      }
</script>
</head>
<BODY background="/images/framebg.gif" onLoad="submitParentForm()">
	<p class="bluehead0">Change Password</p>
	<p class="bluehead4">You are logged on as user <B>$USER</B></p>
	<br>$message
        <br><a href="#" onclick="window.close()">Close</a>
</BODY></HTML>
END_of_html
