/*
# ************************************************************
# @(#) web/webserver/javascript/elementlist.js web_r3.6.0.8:cset.001111:22:33@(#)
#
#   Filename    : web/webserver/javascript/elementlist.js
#
# *************************************************************
#
#                   COPYRIGHT NOTICE
#
# This file remains the intellectual property of:
#
#                       Vallent
#                    Spencer House
#                    23 Sheen Road
#                 Richmond, Surrey, UK
#
# Copyright (c) 2005 Vallent Software Systems UK. All rights reserved.
#
# **************************************************************
#
#   Description :
#
# ************************************************************
#
*/
debug("loading elementlist functions");

// global variables
var imgsrc = {
     open:      "/images/elements/folderopen.gif",
     closed:    "/images/elements/folder.gif",
     leaf:      "/images/elements/leaf.gif",
     working:   "/images/elements/working.gif"
};
var elementListWindow = null;
var bufferNum = 1 ;                    // identifies new buffer <IFRAME> and <BUTTON>
var bufferLookUp = new Object() ;      // build lookup table for _childNode => bufferNumber
bufferLookUp[ 9999 ] = 9999 ;

/*
 ***********************************************************************
 *
 * Name        : _viewElementList()
 *
 * Parameters  : object - <input> object
 *
 * Description : view element list
 *
 * Returns     : nothing
 *
 * Called By   : generated graph/report form
 *
 ***********************************************************************
*/
function _viewElementList( object ) {
    debug("info - IN: _viewElementList()") ;
    
    var fldlist = object.getAttribute( "currlist" ).split(":") ;
    //alert(fldlist.length + " AND " + fldlist[0]);
    var i=0;
    var IdVal = "";
    for (i=0;i<fldlist.length;i++) {
	    var fldID = fldlist[i];
	    var fldVal = document.getElementById(fldID).value;
	    if (fldVal) {
	    	IdVal = IdVal + fldID + "=" + fldVal + ":";
    	}
    }

    var value = object.getAttribute( "href" ) + "&CURRLIST=" + IdVal ;
    
    // check value exists
    if( value == null ) {
        alert( "There are problems with the select box mechanism.\\nPlease contact your system administrator." );
        return;
    }

    var rand=Math.random() * 10000;
    var number = Math.round(rand);
    var unique_name = "ElementList_" + number;
    elementListWindow = window.open(value, unique_name , 'width=280,height=400,scrollbars,resizable') ;

    //elementListWindow = window.open(value, 'ElementList', 'width=280,height=400,scrollbars,resizable') ;
    //JRC 19/08/02 Bug #29628    elementListWindow.location.href = value ;
    elementListWindow.focus() ;

    debug("info - OUT: _viewElementList()") ;
}

/*
 ***********************************************************************
 *
 * Name        : removeElemList()
 *
 * Parameters  : none
 *
 * Description : remove the element selection window, when the parent page in unloaded
 *
 * Returns     : nothing
 *
 * Called By   : StdHeadet.htm and counterBrowser.htm
 *
 ***********************************************************************
*/
function removeElemList(){
    //remove the element selection window, when the parent page in unloaded
    //called from StdHeadet.htm and counterBrowser.htm
    debug("info - removing element selection window");

    if (elementListWindow != null )
      if (!elementListWindow.closed)
        elementListWindow.close();

}

/*
 ***********************************************************************
 *
 * Name        : _view()
 *
 * Parameters  : _childNode - the _parentNode number to manipulate
 *
 * Description : show/hide child nodes
 *
 * Returns     : nothing
 *
 * Called By   : parentNode elements generated by frm_Select.htm
 *
 ***********************************************************************
*/
function _view( _childNode ) {
    debug("info - IN: _view()") ;

    // get the <li> element that we need to manipulate
    _parentNode = document.getElementById( "element" + _childNode ) ;

    // check if _parentNode exists and is open
    if ( ! ( _parentNode.getAttribute( "open" ) ) || _parentNode.getAttribute( "open" ) == "no" ) {
        debug("info - showing childNode: "+_childNode) ;

        _parentNode.setAttribute( "open", "yes" ) ;
        _parentNode.style.listStyleImage = "url(/images/elements/folderopen.gif)" ;

        // check if selected _parentNode was open previously
        if ( ! ( bufferLookUp[ _childNode ] ) ) {
            debug("info - loading childNodes") ;

            // Set the variables in the form
            document.nprform.HLEVEL.value 				= _parentNode.childNodes.item( 0 ).getAttribute( "hlevel" ) ;
            document.nprform.CURRSELECTFOR.value 	= _parentNode.childNodes.item( 0 ).getAttribute( "currselectfor" ) ;
            document.nprform.CURRLIST.value   		= _parentNode.childNodes.item( 0 ).getAttribute( "currlist" ) ;
            document.nprform.CHILDNODE.value    	= _childNode ;
            
            if (document.nprform.HLEVEL.value < 0) {
	            document.nprform.CURRSELECT.value   = _parentNode.childNodes.item( 0 ).getAttribute( "currselect" ) ;
            }
            
            if (document.nprform.HLEVEL.value < 1) {
	            document.nprform.CURRSELECTBY.value   = _parentNode.childNodes.item( 0 ).getAttribute( "currselectby" ) ;
            }
            
            // create <div> showing "Loading ..."
            loadingDiv = document.createElement( "div" ) ;
            loadingDiv.setAttribute( "id", "imageDiv" ) ;

            loadingImg = document.createElement( "img" ) ;
            loadingImg.setAttribute( "src", imgsrc.working ) ;
            loadingImg.setAttribute( "id", "imageWorking" ) ;

            loadingDiv.appendChild( loadingImg ) ;

            // append image to selection
            _parentNode.appendChild( loadingDiv ) ;

            bufferNum++ ;

            // build lookup table for _childNode => bufferNumber
            bufferLookUp[ _childNode ] = bufferNum ;

            // create IFRAME called buffer<bufferNum>
            //document.body.insertAdjacentHTML( "beforeEnd", "<iframe id=buffer"+bufferNum+" height=0 width=0 frameborder=0 name=buffer"+bufferNum+" childNode="+_childNode+"  ></iframe>" ) ;

            // create BUTTON called button<bufferNum>
            //document.body.insertAdjacentHTML("beforeEnd", "<input id=button"+bufferNum+" style='display:none' childNode="+_childNode+" type=button name=button"+bufferNum+" onclick='_loadBuffer(this)'>" ) ;
            
            // BUG 56908 : (Bluewash) insertAdjacentHTML(), insertAdjacentText() and insertAdjacentElement()
	    			insertHTMLElementBeforeEnd("<iframe id=buffer"+bufferNum+" height=0 width=0 frameborder=0 name=buffer"+bufferNum+" childNode="+_childNode+"  ></iframe>");
	    			insertHTMLElementBeforeEnd("<input id=button"+bufferNum+" style='display:none' childNode="+_childNode+" type=button name=button"+bufferNum+" onclick='_loadBuffer(this)'>")

            // give the expanding _parentNode the correct buffer number
            document.nprform.BUTTON.value = "button" + bufferNum ;

            // tell the form which IFRAME to go to
            document.nprform.target = "buffer" + bufferNum ;

            // submit form
            document.nprform.submit() ;
        } else {
            debug("info - make loaded childNode visible") ;
            // lookup childNode previously definned
            _parentNode.childNodes.item( 1 ).style.display = '' ;
        }
    } else {
        debug("info - hiding childNodes") ;
        _parentNode.setAttribute( "open", "no" ) ;
        _parentNode.style.listStyleImage = "url(/images/elements/folder.gif)" ;
        _parentNode.childNodes.item( 1 ).style.display = 'none' ;
    }
    debug("info - OUT: _view()") ;

}

/*
 ***********************************************************************
 *
 * Name        : _loadBuffer()
 *
 * Parameters  : bufferButton - <input> element object which contains
 *               the childNodes
 *
 * Description : display internal frame buffer
 *
 * Returns     : nothing
 *
 * Called By   : internal frame buffer of each childNode
 *
 ***********************************************************************
*/
function _loadBuffer( bufferButton ) {
    debug("info - IN: _loadBuffer()") ;

    // get parent
    _parentNode = document.getElementById( "element" + bufferButton.getAttribute( "childNode" ) ) ;

    // put the buffer contents in child
    _parentNode.childNodes.item( 1 ).innerHTML = bufferButton.value ;

    debug("info - OUT: _loadBuffer()") ;
}

/*
 ***********************************************************************
 *
 * Name        : _selectElement()
 *
 * Parameters  : elementName  - primary key column name
 *               elementValue - column value
 *
 * Description : display internal frame buffer
 *
 * Returns     : nothing
 *
 * Called By   : childNode elements generated by frm_Select.htm
 *
 ***********************************************************************
*/
function _selectElement( elementName, elementValue ) {
    debug("info - IN: _selectElement()") ;

    nprInput = window.opener.document.nprform1.getElementsByTagName( "input" ) ;
    
    if (!elementValue)	{
	    alert("undefined value for " + elementName);
	    return;
    }

    nprInput[ elementName ].value = elementValue ;

    //JRC - give text window focus and then current window focus to ensure
    //OnlyOneAllowed function works as required
    nprInput[ elementName ].focus();
    window.focus();

    debug("info - OUT: _selectElement()") ;
}

function _convertSelection( elementValue ) {
		document.getElementById("origQuery").value=elementValue;
}
