/*
# ************************************************************
# @(#) web/webserver/javascript/tree.js web_r3.6.0.8:cset.001111:22:33@(#)
#
#   Filename    : /webserver/javascript/tree.js
#
# *************************************************************
#
#                   COPYRIGHT NOTICE
#
# This file remains the intellectual property of:
#
#                       Vallent
#                    Spencer House
#                    23 Sheen Road
#                 Richmond, Surrey, UK
#
# Copyright (c) 2005 Vallent Software Systems UK. All rights reserved.
#
# **************************************************************
#
#   Description :
#
# ************************************************************
#
*/
debug('loading tree class');

var imgsrc = {
     open:      "/images/elements/folderopen.gif",
     closed:    "/images/elements/folder.gif",
     leaf:      "/images/elements/leaf.gif",
     working:   "/images/elements/working.gif"
};


var elementListWindow = null ;

function printRange() {
  var range = document.body.createTextRange() ;
  if ( range != null ) {
    debug( range.htmlText ) ;
  }
}


function getSelect( object ) {
    debug("info - entering getSelect") ;

    var value = object.getAttribute( "href" ) ;
    // check value exists
    if( value == null ) {
        alert( "There are problems with the select box mechanism.\\nPlease contact your system administrator." );
        return;
    }

    var rand=Math.random() * 10000;
    var number = Math.round(rand);
    var unique_name = "ElementList_" + number;
    elementListWindow = window.open(value, unique_name , 'width=280,height=400,scrollbars,resizable') ;

    //elementListWindow = window.open(value, 'ElementList', 'width=280,height=400,scrollbars,resizable') ;
// JRC 19/08/02 - Bug #29628    elementListWindow.location.href = value ;
    elementListWindow.focus() ;

    debug("info - leaving getSelect") ;
}

function removeElemList(){
    //remove the element selection window, when the parent page in unloaded
    //called from StdHeadet.htm and counterBrowser.htm
    debug += "info - removing element selection window \n";

    if (elementListWindow != null )
      if (!elementListWindow.closed)
        elementListWindow.close();

}

// global variables

var bufferNum = 0 ; 			       // identifies new buffer <IFRAME> and <BUTTON>
var bufferLookUp = new Object() ;      // build lookup table for branchIndex => bufferNumber

// ***********************************************************************
// *
// * Name		 : expandBranch
// *
// * Description : open or close an expandable branch
// *
// * Parameters  : pass-by-value
// *                   branchIndex - the branch number to manipulate
// *
// * Returns     :
// *
// ***********************************************************************
function expand( newBranch, branchIndex ) {

    debug("info - entering expand") ;
    debug("info - populating branch " + branchIndex) ;

    // get the <li> element that we need to manipulate
    branch = document.getElementById( "element" + branchIndex ) ;

    // get the <img> element
    branchChild = branch.childNodes.item( 0 ).childNodes.item( 0 ) ;

    // check if branch is open
	if ( ! ( branch.getAttribute( "open" ) ) || branch.getAttribute( "open" ) == "no" ) {
        debug("info - opening branch") ;

		branch.setAttribute( "open", "yes" ) ;

		// show open folder image
		branchChild.setAttribute( "src", imgsrc.open ) ;

		// Set the variables in the form
		document.nprform.SELECTLIST.value	= branchChild.getAttribute( "selectlist" ) ;
		document.nprform.QUERYTYPE.value	= branchChild.getAttribute( "querytype" ) ;
		document.nprform.PASSNUM.value	    = branchChild.getAttribute( "passnum" ) ;
		document.nprform.QUERYVALUE.value	= branchChild.getAttribute( "queryvalue" ) ;
		document.nprform.BRANCHINDEX.value	= branchIndex ;

        // create <div> showing "Loading ..."
        myDivChild = document.createElement( "div" ) ;
        myDivChild.setAttribute( "id", "branch" ) ;

        myImg1Child = document.createElement( "img" ) ;
        myImg1Child.setAttribute( "src", imgsrc.working ) ;
        myImg1Child.setAttribute( "id", "imageWorking" ) ;

        myDivChild.appendChild( myImg1Child ) ;

        // append image to selection
        branch.appendChild( myDivChild ) ;

		// check if selected branch was open previously
		debug("info - buffer lookup = " + bufferLookUp[ branchIndex ]);
		if ( ! ( bufferLookUp[ branchIndex ] ) ) {
			debug("info - nothings been defined") ;

            window.status = "Loading tree branch..." ;

		    bufferNum++ ;

		    // build lookup table for branchIndex => bufferNumber
		    bufferLookUp[ branchIndex ] = bufferNum ;

			// create IFRAME called buffer<bufferNum>
		  //  document.body.insertAdjacentHTML( "beforeEnd", "<iframe id=buffer"+bufferNum+" height=0 width=0 frameborder=0 name=buffer"+bufferNum+" branchIndex="+branchIndex+"  ></iframe>" ) ;
		  //  debug("info - iframe created") ;

			// create BUTTON called button<bufferNum>
		  //  document.body.insertAdjacentHTML("beforeEnd", "<input id=button"+bufferNum+" style='display:none' branchIndex="+branchIndex+" type=button name=button"+bufferNum+" onclick='bufferLoaded(this)'>" ) ;
            
      // BUG 56908 : (Bluewash) insertAdjacentHTML(), insertAdjacentText() and insertAdjacentElement()
	    insertHTMLElementBeforeEnd("<iframe id=buffer"+bufferNum+" height=0 width=0 frameborder=0 name=buffer"+bufferNum+" branchIndex="+branchIndex+"  ></iframe>");
	    insertHTMLElementBeforeEnd("<input id=button"+bufferNum+" style='display:none' branchIndex="+branchIndex+" type=button name=button"+bufferNum+" onclick='bufferLoaded(this)'>");

			// give the expanding branch the correct buffer number
		    document.nprform.BUTTON.value = "button" + bufferNum ;

			// tell the form which IFRAME to go to
		    document.nprform.target = "buffer" + bufferNum ;

			// submit form
		    document.nprform.submit() ;
        } else {
        	// lookup branch previously definned
            branch.childNodes.item( 1 ).innerHTML = document.getElementById( "button" + bufferLookUp[ branchIndex ] ).getAttribute( "value" ) ;
        }
	} else {
		// remove branch. Why childNode 2?, because that's where the text was appended
        branch.removeChild( branch.childNodes.item( 1 ) ) ;
		branchChild.setAttribute( "src", imgsrc.closed ) ;
		branch.setAttribute( "open", "no" ) ;
        debug("info - closing branch") ;
	}
    window.status = "" ;
    debug("info - leaving expand") ;

}

// ***********************************************************************
// *
// * Name		 : bufferLoaded
// *
// * Description : displays internal frame buffer
// *
// * Parameters  : pass-by-value
// *                   bufferButton - <input> element object
// *
// * Returns     :
// *
// ***********************************************************************
function bufferLoaded( bufferButton ) {
	debug("info - entering bufferLoaded") ;

	var bufferText = bufferButton.value ;
    // get parent
    branch = document.getElementById( "element" + bufferButton.getAttribute( "branchIndex" ) ) ;

    // put the buffer contents in child
    branch.childNodes.item( 1 ).innerHTML = bufferText ;

    window.status = "Done." ;
    debug("info - leaving bufferLoaded") ;
}


function NPRSelectCell( QueryVar, pCell ) {
	debug("info - entering NPRSelectCell") ;

    nprInput = window.opener.document.nprform1.getElementsByTagName( "input" ) ;

    nprInput[ QueryVar ].value = pCell ;

    debug("info - leaving NPRSelectCell") ;
}


















// procedure description template

// ***********************************************************************
// *
// * Name		 :
// *
// * Description :
// *
// * Parameters  :
// *
// * Returns     :
// *
// ***********************************************************************
